#ifndef S_SCTRL_SM1_hwfunct_H
#define S_SCTRL_SM1_hwfunct_H


#define HW_LIB_HDR_VERSION "1.23"

/* hardware functions 
 * ver 1.0  
 * ver 1.1x   connectors signal working   
 * ver 1.20   added serialnr read
 
 
 */
typedef struct  {
    // BI-SPI 
    DigitalInOut * msio[2];
    DigitalOut * sclk[2];
    DigitalOut * direction[2];
    DigitalOut * stio_mo[2];
    DigitalOut * csb1[2];
    DigitalOut * csb2[2];

    // SPI pins
    DigitalOut * mosi[2]; 
    DigitalIn * miso[2]; 
    DigitalOut * t_cs[2];
    DigitalOut * tc_cs1[2];
    DigitalOut * tc_cs2[2];
    DigitalOut * dac_cs[2];
    DigitalOut * dac_rst[2];

    //cal 
    DigitalOut * cal13[2]; // physical the same so will point to the same port
    DigitalOut * cal24[2]; // physical the same so will point to the same port
    DigitalOut * calint[2];
    // not related to connector 1 /2 
    DigitalOut * calext; 
    DigitalOut * calgenext;

    DigitalOut * ledred;
    DigitalOut * ledgreen;

    DigitalIn * snr[5];

    AnalogIn * ain[2];
} HWlines;

void assignports(HWlines * hwlines);    
void setcalsource(int extcal, HWlines hwl);    
void set_bi_spi_mo(int masterout, DigitalInOut * msio, DigitalOut * ldir,
                   DigitalOut * rdir);
void setdefault(HWlines hwl);
char * hwfunct_lib_version(); // returns this lib version info    
int get_serialnr(HWlines * hwlines); // get the electronic serial nr of the board

#endif    